"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_sql_parser_1 = require("@joe-re/node-sql-parser");
const log4js = __importStar(require("log4js"));
const vscode_languageserver_1 = require("vscode-languageserver");
const logger = log4js.getLogger();
function createDiagnostics(uri, sql) {
    logger.debug(`createDiagnostics`);
    let diagnostics = [];
    try {
        const ast = node_sql_parser_1.parse(sql);
        logger.debug(`ast: ${JSON.stringify(ast)}`);
    }
    catch (e) {
        logger.debug('parse error');
        logger.debug(e);
        if (e.name !== 'SyntaxError') {
            throw e;
        }
        diagnostics.push({
            range: {
                start: { line: e.location.start.line - 1, character: e.location.start.column },
                end: { line: e.location.end.line - 1, character: e.location.end.column }
            },
            message: e.message,
            severity: vscode_languageserver_1.DiagnosticSeverity.Error,
            // code: number | string,
            source: 'sql',
            relatedInformation: []
        });
    }
    logger.debug(JSON.stringify(diagnostics));
    return { uri: uri, diagnostics };
}
exports.default = createDiagnostics;
//# sourceMappingURL=createDiagnostics.js.map