"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const log4js = __importStar(require("log4js"));
const logger = log4js.getLogger();
class AbstractClient {
    constructor(settings) {
        this.settings = settings;
    }
    async getSchema() {
        let schema = [];
        try {
            this.connect();
            const tables = await this.getTables();
            schema = await Promise.all(tables.map((v) => this.getColumns(v).then(columns => ({
                database: this.settings.database,
                tableName: v,
                columns: columns.map(v => this.toColumnFromRawField(v))
            }))));
            this.disconnect();
        }
        catch (e) {
            this.disconnect();
            logger.error(e);
            throw e;
        }
        return schema;
    }
    toColumnFromRawField(field) {
        return {
            columnName: field.field,
            description: `${field.field}(Type: ${field.type}, Null: ${field.null}, Default: ${field.default})`
        };
    }
}
exports.default = AbstractClient;
//# sourceMappingURL=AbstractClient.js.map